---------------------------------------------------------------------
------------------------ All freeslot Extra  ------------------------
---------------------------------------------------------------------


--Sprites
freeslot("SPR2_JA_T", "SPR2_TFCA", "SPR2_TFBO", "SPR2_TFBR", "SPR_EMPT", "SPR_BLST", "SPR_BULL", "SPR_TRCK", "SPR2_BUSN", "SPR2_BUJU")
--States
freeslot("S_PONTIAC_MODE", "S_TF_TO_BOT", "S_TF_TO_BOT_BR",
"S_TF_TO_CAR", "S_BLAST_SHOT", "S_BLAST_EXPLODE", "S_BLAST_DUST", "S_BULL_SHOT", "S_WEAPON_STANCE",
 "S_CLIMBING", "S_TRCK", "S_FIRE", "S_EMPTY_MAG_VISUAL")

--Sounds
freeslot("sfx_tf_car", "sfx_tf_bot", "sfx_rev", "sfx_idle", "sfx_mid", "sfx_high", "sfx_brake", "sfx_bump", "sfx_horn", 
"sfx_bullet", "sfx_hit", "sfx_miss", "sfx_blast", "sfx_expld", "sfx_blrel", "sfx_burel", "sfx_empty", "sfx_land", "sfx_climb",
"sfx_begn01", "sfx_begn02", "sfx_begn03", "sfx_begn04", "sfx_begn05", "sfx_win01", "sfx_win02", "sfx_win03", "sfx_win04", "sfx_win05", "sfx_easy")

--Objects
freeslot("MT_WBLS", "MT_WBUL", "MT_TRCK", "MT_FIRE", "MT_BDST", "MT_EMPT")


------------------------------------------------------------------------------------
------------------------ All rawset Variables and Functions ------------------------
------------------------------------------------------------------------------------
--- NOTE: Constant variables are FULLY CAPITALIZED (don't change constants!!!) -----
------------------------------------------------------------------------------------


--------------- Any Mode Constants ---------------
rawset(_G, "SKINS", {JAZZ = "jazz", BARRICADE = "barricade"})

--Transformation
rawset(_G, "TF_MODES", {BOT_MODE = 0, CAR_MODE = 1}) -- Simulates Enums for all possible transformation modes
rawset(_G, "TRANFORMATION_TICS_MAX", TICRATE/4) --The cooldown of the transformation


--Special Speed Boosts for bot mode
rawset(_G, "SPECIAL_BOOST_TICS_MAX", 5*TICRATE) -- Maximum speedup time by the special ability
rawset(_G, "SPECIAL_BOOST_RING_TICS", 9) -- How much tics added to special speed boost timer when picking up a ring
rawset(_G, "SPECIAL_BOOST_DMG_TICS", 25)
rawset(_G, "SPECIAL_BOOST_MONITOR_TICS", 15)
rawset(_G, "SPECIAL_BOOST_SPRING_TICS", 25)
rawset(_G, "SPECIAL_BOOST_BOT_SPEED", 6*FRACUNIT) -- The amount of speedup
rawset(_G, "SPECIAL_BOOST_BOT_ACCEL", 20) -- The amount of increased acceleration
rawset(_G, "SPECIAL_BOOST_CAR_SPEED", 15*FRACUNIT) -- For car mode
rawset(_G, "SPECIAL_BOOST_CAR_ACCEL", 1*FRACUNIT) -- For car mode

--Voice related
rawset(_G, "VOICE_VOLUME", 255)
rawset(_G, "BEGN_TICS_MAX", TICRATE/2)

--------------- Car Mode constants ---------------


--Speed related
rawset(_G, "CAR_ACCELERATION", 5*FRACUNIT/2) --Force applied every tic
rawset(_G, "CAR_ACCELERATION_BOOSTED", CAR_ACCELERATION*2) --Force applied every tic while using speed sneakers
rawset(_G, "SPEED_LIMIT", 100*FRACUNIT) --Fastest speed while driving normally
rawset(_G, "SPEED_LIMIT_BOOSTED", 3*SPEED_LIMIT/2) --Fastest speed while driving while using speed sneakers
rawset(_G, "IDLE_SPEED", 2*FRACUNIT) --Up to what speed the engine is in the idle state
rawset(_G, "MID_SPEED", 2*SPEED_LIMIT/3) --Up to what speed the engine is in the middle speed state
rawset(_G, "BREAK_SPEED", 10*FRACUNIT) -- At what minimum speed will Jazz be able to break walls, ceiling, floors, and empower springs
rawset(_G, "STEERING_LIMIT_ANGLE", {MAX = ANG1*7, MIN = ANG1*3}) --The turning angle of steering at minimum speed and maximum speeds
rawset(_G, "REVERSE_SPEED_LIMIT", 10*FRACUNIT) --Fastest speed while driving normally

--Defines the wheel grip car has over the ground
--In-Control: The car is on the ground under perfect circumstances: best control
--Oversteer: The car turned over the limit, player can take advantage to drift: medium control
--No-control The car is either airbone or in low friction area, worst control
rawset(_G, "CAR_TRACTION", {IN_CONTROL = 0, OVERSTEER_CONTROL = 1, NO_CONTROL = 2}) 

--The maximum FRACUNIT angle difference between actual movement angle and movement of the tires, after which oversteering is occuring
rawset(_G, "GRIP_LIMIT", 40*FRACUNIT)  

--Simulating the gear
rawset(_G, "GEAR_MODE", {DRIVE = 0, REVERSE = 2, PARK = 3})  


--Sound related
rawset(_G, "MAX_IDLE_SOUND_TICS", 34)
rawset(_G, "MAX_MID_SOUND_TICS", 47)
rawset(_G, "MAX_HIGH_SOUND_TICS", 26)


--Bumping objects out of hte way
rawset(_G, "BUMP_MF", MF_ENEMY|MF_MONITOR) --Objects that are able to be bumped
rawset(_G, "BUMP_NOT_MF", 0) -- Not used, but intended to detect objects that can't be bumped
rawset(_G, "BUMP_SPEED", BREAK_SPEED) --At what speed car mode can bump objects

--Misc
rawset(_G, "CAR_SHIELD_SCALE", FRACUNIT)


--------------- Bot Mode Constants ---------------


--Weapons
rawset(_G, "BURST_SHOT_INTERVAL_TIC_MAX", 10) --Total period of bullets being shot (not every tic of it)
rawset(_G, "BLAST_KNOCKBACK", 20*FRACUNIT)

rawset(_G, "CRESCENT_MAG_MAX", 1) --Amounts of shots left before empty
rawset(_G, "SLUG_MAG_MAX", 9) --Amounts of shots left before empty
rawset(_G, "SLUG_RELOAD_TICS_MAX", 1*TICRATE) --Reload time for the bullet weapon
rawset(_G, "CRESCENT_RELOAD_TICS_MAX", 2*TICRATE) --Reload time for the blast weapon
rawset(_G, "SLUG_RING_REQUIREMENT", 3) --Required amount of rings to possed in order to use the gun
rawset(_G, "CRESCENT_RING_REQUIREMENT", 5) --Required amount of rings to possed in order to use the gun

--Transformation into bot
rawset(_G, "TO_BOT_JUMP", FRACUNIT*10) --Jump force applied whlie transforming into bot 

--Climbing (maybe deprecated)
rawset(_G, "CLIMB_WALL_DISTANCE", 30*FRACUNIT) --
rawset(_G, "CLIMBING_SPEED", 5*FRACUNIT) --Speed of climbing all four directions



--------------- Functions Mode Constants ---------------


--Clamps the integer num between inlcusive bounds
rawset(_G, "clamp", function(num, lower, upper)
	if(num > upper) then
		num = upper
	elseif(num < lower) then
		num = lower
	end
	return num
	-- return max(lower, min(upper, num))
end)


--Checks whether the mobject is valid and (optionally) has the correct skin 
rawset(_G, "Valid", function(mo, skin)
	return mo ~= nil and mo.valid == true and mo.skin == skin and mo.state ~= S_NULL--and mo.state ~= states[mo.state].deathstate
end)

--Checks whether the mobject is alive, not leaving the level, not being damaged
rawset(_G, "Active", function(player)
	return (player.playerstate == PST_LIVE and player.exiting == 0 and player.mo.state ~= mobjinfo[player.mo.type].painstate)
end)

--Gets the actual absolute speed in 3D space at any angle
rawset(_G, "GetRealSpeed", function(player)
    local vs = abs(player.mo.momz) -- Vertical speed
    local hs = player.speed -- Horizontal speed
	return FixedSqrt(FixedMul(vs, vs) + FixedMul(hs, hs))
	-- return max(lower, min(upper, num))
end)


--Function mostly shown by clairebun to use on SRB2 discord page
--mo1 (mobj_t): first mobj to check for collision
--mo2 (mobj_t): second mobj to check for collision
--extraheight (int): extra height added to the mo2
--returns: true if two mobjects collide vertically, false otherwise
rawset(_G, "L_ZCollide", function(mo1, mo2, extraheight)
	if(extraheight == nil) then
		extraheight = 0
	end
    if mo1.z > mo2.height+mo2.z+extraheight then return false end
    if mo2.z > mo1.height+mo1.z then return false end
    return true
end)

--Spawns the objects on the side of the player
--Returns right and left spawned objects
rawset(_G, "SpawnOnSide", function(player, toSpawn)
    local right_x = player.mo.x + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(cos(player.mo.angle+ANGLE_90)), player.mo.scale)) 
    local right_y = player.mo.y + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(sin(player.mo.angle+ANGLE_90)), player.mo.scale)) 
    local left_x  = player.mo.x + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(cos(player.mo.angle-ANGLE_90)), player.mo.scale)) 
    local left_y  = player.mo.y + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(sin(player.mo.angle-ANGLE_90)), player.mo.scale)) 
    
    local z = player.mo.z
    if(player.mo.eflags & MFE_VERTICALFLIP) then
        z = $ + player.mo.height - mobjinfo[toSpawn].height
    end

    --Spawn at the side
    local right = P_SpawnMobj(right_x, right_y, z, toSpawn)
    local left = P_SpawnMobj(left_x, left_y, z, toSpawn)

    right.scale = player.mo.scale
    left.scale = player.mo.scale

    return right, left
end)


--Switch to the jazz skin
--Returns true if could switch to jazz, false if player was already it
rawset(_G, "SwitchTo", function(player)
	-- if(Valid(player.mo, "Jazz")) then
	-- 	return false -- do not switch to jazz if the player is already jazz
	-- end
    
	--Set controls
	player.jumpheld = 0
	player.spinheld = 0
    player.forwardheld = 0
	player.prevjumpheld = 0
	player.prevspinheld = 0
    player.mo.prevtics = 0
    player.mo.prevframemask = 0

    player.mo.prevstate = player.mo.state
	
    --The previous vertical momentum
    player.mo.prevmomz = 0
	
    --Is jump special available?
    player.jumpspecial = 0 -- true if releasing jump in the air, enable implementing jumping special abilities manual
    
    --The current transformation mode of jazz
    if(player.tf_mode == nil) then
        player.tf_mode = TF_MODES.BOT_MODE -- The default jazz mode is botmode
    end
    player.transformation_tics = TRANFORMATION_TICS_MAX --Transformation is allowed only when tics <= 0 (so this is its cooldown)
    player.burst_shot_interval_tics = 0 --Current bullet tic countdown

    player.crescent_mag = CRESCENT_MAG_MAX -- Shots left in the mag
    player.slug_mag = SLUG_MAG_MAX -- Shots left in the mag
    player.crescent_reload_tics = CRESCENT_RELOAD_TICS_MAX --How long it takes to reload
    player.slug_reload_tics = SLUG_RELOAD_TICS_MAX --How long it takes to reload

    player.special_boost_tics = 0 -- Current tic countdown, applying special speed boost while tic counter is above 0

    player.sfx_begn_tics = -1 -- Voiceline countdown, executes only when equal 0
    player.sound_tics_idle = MAX_IDLE_SOUND_TICS --Sound countdowns
    player.sound_tics_mid = MAX_MID_SOUND_TICS --Sound countdowns
    player.sound_tics_high = MAX_HIGH_SOUND_TICS --Sound countdowns
    
    player.mo.car_traction = CAR_TRACTION.NO_CONTROL
    player.mo.car_gear = GEAR_MODE.PARK
    player.mo.car_accel = 0 --Speed applied every tic
    player.mo.car_forward_angle = player.mo.angle --What is the movement (forward or front) angle of the car
    player.car_steer_input = 0 --Player's input on the steering buttons, between -1000 and 1000
    player.car_gas_input = 0 --Player's input on the gas button, between 0 and 1
    player.car_brake_input = 0 --Player's input on the brake button, between 0 and 1

    -- True if the jazz was on the ground in the previous frame
    player.mo.car_prevground = true

    --List of bosses found on this level
    player.bosses_detected = {}

    return true
end)


--Switch off the jazz skin
--Returns true if could switch offset jazz, false if player wan't jazz in the first place
rawset(_G, "SwichOff", function(player)
	-- if(Valid(player.mo)) then
		-- return false
	-- end

    if(player.tf_mode == TF_MODES.CAR_MODE) then
        player.mo.state = S_TF_TO_BOT
    end

    --Remove controls
	player.jumpheld = nil
	player.spinheld = nil
    player.forwardheld = nil
	player.prevjumpheld = nil
	player.prevspinheld = nil

	player.mo.prevmomz = nil
	player.jumpspecial = nil

    player.tf_mode = nil
    player.transformation_tics = nil
    
    player.mo.steering = nil

    player.mo.car_accel = nil
    player.mo.applied_angle = nil
    player.forward_input = nil
    player.braking_input = nil

    player.mo.car_prevground = nil
    player.mo.prevskin = nil

    return true
end)


--Adds time to the special boost ability
local function AddSpecialBoostTics(player, tics)
    if(player.special_boost_tics == nil) then
        player.special_boost_tics = 0
    end
    player.special_boost_tics = clamp($ + tics, 0, SPECIAL_BOOST_TICS_MAX) 
end


--Be able to break obstacles and power up springs by reaching a certain speed limit
local function PowerUp(player, limit)
    --Break speed
    local speed = GetRealSpeed(player)
    
    --Bust objects in car mode
    if(speed > limit and player.tf_mode == TF_MODES.CAR_MODE) then
        player.powers[pw_strong] = $|STR_BUST|STR_SPIKE
    else
        player.powers[pw_strong] = $&~STR_BUST&~STR_SPIKE
    end

end


local function ReloadThink(player)
    --Try reloading the Slug Repeater (bullet weapon)
    if(player.slug_mag <= 0) then -- If slug has no ammo
        --Timers
        if(player.slug_reload_tics <= 0) then --Has reload timer ran out?
            player.slug_mag = SLUG_MAG_MAX --Fully reload
            player.slug_reload_tics = SLUG_RELOAD_TICS_MAX --reset timer
            S_StartSound(player.mo, sfx_burel)
        else --Reload timer has to keep going
            --Count down time until reload
            player.slug_reload_tics = $-1
        end
        
    end
    --Try reloading the Crescent Blaster (blast weapon)
    if(player.crescent_mag <= 0) then -- If crescent has no ammo
        --Timers
        if(player.crescent_reload_tics <= 0) then --Has reload timer ran out?
            player.crescent_mag = CRESCENT_MAG_MAX --Fully reload
            player.crescent_reload_tics = CRESCENT_RELOAD_TICS_MAX --reset timer
            S_StartSound(player.mo, sfx_blrel)
        else --Reload timer has to keep going
            --Count down time until reload
            player.crescent_reload_tics = $-1
        end
        
    end

end


local function ApplyBotStats(actor)

    -- Restore the original height
    actor.player.height = skins[actor.player.skin].height
    actor.player.shieldscale = skins[actor.skin].shieldscale

    -- Change the current transformation state
    actor.player.tf_mode = TF_MODES.BOT_MODE
    actor.player.transformation_tics = TRANFORMATION_TICS_MAX -- resetting transformation tics

    actor.player.charflags = $&~SF_NOSKID


    if(not S_SoundPlaying(actor, sfx_tf_bot)) then
        -- Play sound
        S_StartSound(actor, sfx_tf_bot)
    end

    -- Stop car sounds
    S_StopSoundByID(actor, sfx_brake)
    S_StopSoundByID(actor, sfx_rev)
    S_StopSoundByID(actor, sfx_idle)
    S_StopSoundByID(actor, sfx_mid)
    S_StopSoundByID(actor, sfx_high)
end

------------------------------------------------------------
------------------ All Sound definitions -------------------
------------------------------------------------------------


------------------------------ Transformation sounds
-- Transformion to car
sfxinfo[sfx_tf_car] = {
	singular = false,
	priority = 64
}

-- Transformion to bot
sfxinfo[sfx_tf_bot] = {
	singular = false,
	priority = 64
}
------------------------------ Car sounds
-- Starting the engine
sfxinfo[sfx_rev] = {
	singular = false,
	priority = 65
}
-- No movement
sfxinfo[sfx_idle] = {
	singular = false,
	priority = 65
}
-- Medium speed
sfxinfo[sfx_mid] = {
	singular = false,
	priority = 65
}

-- High to max speed
sfxinfo[sfx_high] = {
	singular = false,
	priority = 65
}
-- Braking sound
sfxinfo[sfx_brake] = {
    singular = false,
	priority = 64
}
-- Bumping sound
sfxinfo[sfx_bump] = {
    singular = false,
	priority = 64
}
-- Horn sound
sfxinfo[sfx_horn] = {
    singular = false,
	priority = 66
}
------------------------------ Bot sounds
-- Sound of slug bullet firing
sfxinfo[sfx_bullet] = {
	singular = false,
	priority = 64
}
-- Sound of bullet hitting an enemy with a bullet
sfxinfo[sfx_hit] = {
	singular = false,
	priority = 64
}
-- Sound of bullet hitting a wall with a bullet
sfxinfo[sfx_miss] = {
    singular = false,
	priority = 64
}
--Sounds of crescent blast firing 
sfxinfo[sfx_blast] = {
    singular = false,
	priority = 64
}
sfxinfo[sfx_expld] = {
    singular = false,
	priority = 64
}
-- Sound of landing on the ground
sfxinfo[sfx_land] = {
	singular = false,
	priority = 64
}
-- Sound of climbing on the wall
sfxinfo[sfx_climb] = {
	singular = false,
	priority = 64
}
--Sounds of trying to use a weapon with empty mag
sfxinfo[sfx_empty] = {
	singular = false,
	priority = 64
}
-- Sound of reloading the Crescent Blaster blast weapon
sfxinfo[sfx_blrel] = {
	singular = false,
	priority = 64
}
-- Sound of reloading the Slug Repeater bullet weapon
sfxinfo[sfx_burel] = {
	singular = false,
	priority = 64
}
------------------------------ Voicelines sounds
--Played during getting a level-up and related actions
sfxinfo[sfx_easy] = {
    singular = false,
    priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn01] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn02] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn03] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn04] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn05] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win01] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win02] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win03] = {
    singular = false,
	priority = 64
}

--Winning a boss fight
sfxinfo[sfx_win04] = {
    singular = false,
	priority = 64
}

--Winning a boss fight
sfxinfo[sfx_win05] = {
    singular = false,
	priority = 64
}



--------------------------------------------------------------------
------------------------ Important Thinkers ------------------------
--------------------------------------------------------------------


--The Base Thinker that plays before others,
--Mostly used to record players input
addHook("PreThinkFrame", function()
	for player in players.iterate() do
        
        -- print("S: "..player.mo.skin)
        -- print("P: "..player.mo.prevskin)

        if(player.mo.prevskin ~= player.mo.skin) then
            --Skin switching behavior
            if(player.mo.prevskin == "jazz") then
                SwichOff(player)
            elseif(player.mo.skin == "jazz" or player.mo.prevskin == nil) then
                SwitchTo(player)
            end
        end

        -- print("PS: "..player.mo.skin)
        -- print("PP: "..player.mo.prevskin)
        
        
        --Prevent any non-jazz players to execute behavior afte rit
        -- continue -- Try find the next jazz player if current is not jazz
        if(player.mo.skin == "jazz") then


            --Stop falling animation on last 
            if(player.mo.state == S_PLAY_FALL) then
                if(player.mo.frame & FF_FRAMEMASK == C) then
                    player.mo.frame = $
                    player.mo.tics = -1
                end
            end
        
            -- Prevent drowning in liquid and suffocating in space
            player.powers[pw_underwater] = 0
            player.powers[pw_spacetime] = 0

            -- Controls 
            --Jump button
            if(player.cmd.buttons & BT_JUMP) then
                player.jumpheld = $+1
            else
                player.jumpheld = 0
            end

            --Spin button
            if(player.cmd.buttons & BT_SPIN) then
                player.spinheld = $+1
            else
                player.spinheld = 0
            end

            --Forward button (accounting for joystick too)
            if(player.cmd.forwardmove >= 40) then
                player.forwardheld = $+1
            else
                player.forwardheld = 0
            end

            --Jump special ability (available when letting go of jump button in the air)
            if(not P_IsObjectOnGround(player.mo) and player.jumpheld == 0 and player.climbing == 0 ) then
                player.jumpspecial = 1
            elseif(player.mo.eflags & MFE_JUSTHITFLOOR or player.powers[pw_carry] ~= 0) then
                player.jumpspecial = 0
            end

        end
    end
end)





-- Regular behaviors for both modes (such as Passive Skills)
addHook("PlayerThink", function(player)
    
    if(not Valid(player.mo, "jazz")) then
        return 
    end

    if(player.special_boost_tics > 0) then --Special speed boost is in the affect
        player.special_boost_tics = $-1 --Counting down special speed boost timer
    end


    PowerUp(player, BREAK_SPEED)
    
    --Reload the weapons if needed
    ReloadThink(player)
    

    --Add special time if using a spring
    if(player.powers[pw_justsprung] ~= 0) then
        AddSpecialBoostTics(player, SPECIAL_BOOST_SPRING_TICS)
    end
    
    local radius = 1000*FRACUNIT

    --Find boss nearby
    searchBlockmap("objects", function(jazzmo, foundmo)
        if(foundmo.valid and foundmo.flags & MF_BOSS == 0) then
            return -- Stop if boss is not actually a boss
        end
        --Make sure that this boss wasn't detected
        for index, boss in ipairs(jazzmo.player.bosses_detected) do
            if boss == foundmo then
                return true
            end
        end
        --Add the boss to the list of detected bossed on this level
        table.insert(jazzmo.player.bosses_detected, foundmo)
        --Start the countdown that will trigger the voiceline
        if(player.sfx_begn_tics < 0) then
            player.sfx_begn_tics = BEGN_TICS_MAX
        end
    end, player.mo,player.mo.x-radius, player.mo.x+radius, player.mo.y-radius, player.mo.y+radius)

    --Play the sound if the timer ended
    if(player.sfx_begn_tics == 0) then
        S_StartSound(player.mo, P_RandomRange(sfx_begn01,sfx_begn05)) --Play sound when found 
    end
    --Keep counting down the voiceline timer
    if(player.sfx_begn_tics >= 0) then
        player.sfx_begn_tics = $-1
    end


end)


local function KeepState(player, state_num)
    
end


--The Thinker that plays after other thikers,
--mostly used to clean up, record the previous state, 
--and jump and spin button holding
addHook("PostThinkFrame", function()
	for player in players.iterate() do
        
		if(Valid(player.mo, "jazz")) then

            -- Prevent changing states
            if(player.mo.prevstate == S_TF_TO_CAR and player.mo.eflags & MFE_JUSTHITFLOOR) then
                player.mo.state = S_TF_TO_CAR
                player.mo.tics = player.mo.prevtics
                player.mo.frame = $&~FF_FRAMEMASK|player.mo.prevframemask
            end

            --Keep being in car state

            if(player.tf_mode == TF_MODES.CAR_MODE and player.mo.state ~= S_TF_TO_BOT and player.mo.state ~= S_TF_TO_CAR) then
                player.mo.state = S_PONTIAC_MODE
            end

            --Keep being in breakdancing state when landing
            if(player.mo.state ~= S_TF_TO_BOT_BR and player.mo.prevstate == S_TF_TO_BOT_BR and (player.mo.eflags & MFE_JUSTHITFLOOR or (player.jumpheld < 5 and player.jumpheld > 0))) then
                player.mo.state = S_TF_TO_BOT_BR
            end
            
            --Keep player in shooting stance when landing 
            if(player.mo.prevstate == S_WEAPON_STANCE and player.mo.eflags & MFE_JUSTHITFLOOR)then
                player.mo.state = S_WEAPON_STANCE
            end        
            
            player.prevjumpheld = player.jumpheld
            player.prevspinheld = player.spinheld
            
            player.mo.prevstate = player.mo.state
            player.mo.prevtics = player.mo.tics
            player.mo.prevframemask = player.mo.frame & FF_FRAMEMASK
            
            --Recording if the car was on the ground in previous tic
            player.mo.car_prevground = P_IsObjectOnGround(player.mo)
		end

        player.mo.prevskin = player.mo.skin

	end
end)


addHook("MobjDamage", function(target, inflictor, source, damagetype)

    if(not Valid(source, "jazz")) then
        return --Target wasn't killed by Jazz
    end

    --Jazz killed the enemy
    if(target.flags & MF_ENEMY) then
        AddSpecialBoostTics(source.player, SPECIAL_BOOST_DMG_TICS)
    end

end)


addHook("MobjDeath", function(target, inflictor, source, damagetype)

    if(not Valid(source, "jazz")) then --Target wasn't killed by Jazz
        return 
    end

    if(target.flags & MF_BOSS ~= 0) then --Jazz killed the boss
        --Play sound
        S_StartSound(source, P_RandomRange(sfx_win01,sfx_win05))
    elseif(target.type == MT_RING) then --Jazz collected a ring
        --Adding tics to the boost timer, making sure it doesn't go aboe the limit
        AddSpecialBoostTics(source.player, SPECIAL_BOOST_RING_TICS)
    elseif(target.flags & MF_MONITOR) then --Jazz collected a ring
        if(target.type == MT_1UP_BOX) then
            S_StartSound(source.mo, sfx_easy)
        end
        --Adding tics to the boost timer, making sure it doesn't go aboe the limit
        AddSpecialBoostTics(source.player, SPECIAL_BOOST_MONITOR_TICS)
    end
end)


-------------------------------------------------------------
------------------------ All Actions ------------------------
-------------------------------------------------------------

local function A_BLAST_EXPLODE(blast, var1, var2)
    --Explosion effect
    blast.destscale = 10*FRACUNIT
    blast.scalespeed = FRACUNIT

    local dust = P_SpawnMobjFromMobj(blast, 0, 0, 0, MT_BDST)
    dust.destscale = blast.destscale * 2
    dust.scalespeed = blast.scalespeed * 2


    local search_radius = 1000*FRACUNIT
    local max_distance = FixedMul(blast.radius , blast.destscale)
    local max_height = FixedMul(blast.height , blast.destscale)

    --Find the enemy to hit on the explosion 
    searchBlockmap("objects", function(blastmo, foundmo)

        
        local distance = R_PointToDist2(blastmo.x, blastmo.y, foundmo.x, foundmo.y)
        local height = max(abs(blastmo.z - foundmo.z), abs(foundmo.z - blastmo.z))
        if(foundmo.valid and foundmo.flags & MF_SHOOTABLE|MF_SOLID ~= 0 --Correct flags and validity
        and distance <= max_distance and height <= max_height --Check horizontal and height distances
        and P_CheckSight(blastmo, foundmo) and foundmo.state ~= mobjinfo[foundmo.type].painstate) then
            
            if(blastmo.target == foundmo) then -- Self-damage
                P_DamageMobj(foundmo) 
                P_Thrust(foundmo, R_PointToAngle2(blastmo.x, blastmo.y, foundmo.x, foundmo.y), BLAST_KNOCKBACK)
            else
                P_DamageMobj(foundmo, blastmo, blastmo.target, blastmo.damage)
            end
        end
    end, blast, blast.x-search_radius, blast.x+search_radius, blast.y-search_radius, blast.y+search_radius)
end

local function A_BULLET_STANCE(actor, var1, var2)
    if(not Valid(actor, "jazz")) then
        return false --Wasn't called for jazz
    end

    -- actor.player.burst_shot_interval_tics = BURST_SHOT_INTERVAL_TIC_MAX
end

--Start climbing
local function A_CLIMBING(actor, var1, var2) 
    if(not Valid(actor, "jazz")) then
        return false --Wasn't called for jazz
    end
end


-- Sets up jazz for transformation into the bot
local function A_TF_TO_BOT(actor, var1, var2)
    -- if(not Valid(actor, "jazz")) then
    --     return false --Wasn't called for jazz
    -- end
    ApplyBotStats(actor)

    local fire_button = nil
    if(actor.player == secondarydisplayplayer) then
        fire_button = input.gameControl2Down(GC_FIRE)
    else
        fire_button = input.gameControlDown(GC_FIRE)
    end

    -- Artificial jump while transforming
    if((actor.player.jumpheld >= 1 or fire_button ~= 0) and P_IsObjectOnGround(actor) and actor.eflags & MFE_UNDERWATER == 0) then
        P_SetObjectMomZ(actor, TO_BOT_JUMP, true)
       actor.player.jumpspecial = 1 -- Count as a jump
       --Play jumping animation
       states[actor.state].nextstate = S_PLAY_JUMP
    end
end

local function A_TF_TO_BOT_BR(actor, var1, var2)
    ApplyBotStats(actor)
end


-- Sets up jazz for transformation into the car
local function A_TF_TO_CAR(actor, var1, var2)
    if(not Valid(actor, "jazz")) then
        return false --Wasn't called for jazz
    end

    -- Reduce the height of car to fit into the spingap
    actor.player.height = actor.player.spinheight
    actor.player.shieldscale = CAR_SHIELD_SCALE

    actor.car_forward_angle = actor.angle
    
    actor.player.charflags = $|SF_NOSKID

    -- Change the current transformation state
    actor.player.tf_mode = TF_MODES.CAR_MODE
    actor.player.transformation_tics = TRANFORMATION_TICS_MAX -- resetting transformation tics


    -- Play sound
    if(not S_SoundPlaying(actor, sfx_tf_car)) then
        S_StartSound(actor, sfx_tf_car)
    end
end



------------------------------------------------------------
------------------ All State definitions -------------------
------------------------------------------------------------


--State of shooting bullets 
states[S_WEAPON_STANCE] = {
	sprite = SPR_PLAY,
	frame = SPR2_BUSN,
	tics = TICRATE,
    action = A_BULLET_STANCE,
    nextstate = S_PLAY_STND
}

states[S_CLIMBING] = {
    sprite = SPR_PLAY,
	frame = SPR2_RIDE,
	tics = -1,
    action = A_CLIMBING,
    nextstate = S_PLAY_JUMP
}
--Jazz's Car mode: Pontiac
states[S_PONTIAC_MODE] = {
	sprite = SPR_PLAY,
	frame = SPR2_JA_T,
	tics = -1
}

-- Transformation sequence into the car mode
states[S_TF_TO_CAR] = {
	sprite = SPR_PLAY,
	frame = SPR2_TFCA|FF_ANIMATE|A,
    tics = 2*TICRATE/3,
	action = A_TF_TO_CAR,
    var1 = 4,
    var2 = TICRATE/8,
    nextstate = S_PONTIAC_MODE
}

-- Transformation sequence into the bot mode
states[S_TF_TO_BOT] = {
	sprite = SPR_PLAY,
	frame = SPR2_TFBO|FF_ANIMATE|A,
	tics = states[S_TF_TO_CAR].tics,
	action = A_TF_TO_BOT,
    var1 = states[S_TF_TO_CAR].var1,
    var2 = states[S_TF_TO_CAR].var2,
	nextstate = S_PLAY_STND
}

states[S_TF_TO_BOT_BR] = {
    sprite = SPR_PLAY,
	frame = SPR2_TFBR|FF_ANIMATE|A,
	tics = TICRATE,
	action = A_TF_TO_BOT_BR,
    var1 = 7,
    var2 = TICRATE/15,
	nextstate = S_PLAY_WALK
}

--Jumps the visual out of the player when mag is empty (purely visual)
states[S_EMPTY_MAG_VISUAL] = {
    sprite = SPR_EMPT,
    frame = A,
	tics = TICRATE/2
}

-- Projectile: Blast that is shot
states[S_BLAST_SHOT] = {
	sprite = SPR_BLST,
    frame = A,
	tics = 10*TICRATE
}

-- Projectile: The explosion of the blast
states[S_BLAST_EXPLODE] = {
	sprite = SPR_BLST,
    frame = A|FF_TRANS50,
    action = A_BLAST_EXPLODE,
	tics = TICRATE/3
}

-- Projectile: The dust explosion of the blast
states[S_BLAST_DUST] = {
	sprite = SPR_BLST,
    frame = A|FF_TRANS50|FF_FULLDARK,
	tics = states[S_BLAST_EXPLODE].tics/2
}


-- Projectile: Bullet that is shot
states[S_BULL_SHOT] = {
	sprite = SPR_BULL,
    frame = A,
	tics = TICRATE
}

-- The regular tire trace 
states[S_TRCK] = {
	sprite = SPR_TRCK,
    frame = A,
	tics = 10*TICRATE,
    nextstate = S_NULL
}

-- The regulat tire trace 
states[S_FIRE] = {
	sprite = SPR_SFLM,
    frame = A,
	tics = 10,
    nextstate = S_NULL
}


------------------------------------------------------------
----------------- All Objects definitions ------------------
------------------------------------------------------------

--Empty mag 
mobjinfo[MT_EMPT] = {
    spawnstate = S_EMPTY_MAG_VISUAL,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_NOGRAVITY,
    -- flags = MF_SCENERY
}

--Tire Traces
mobjinfo[MT_TRCK] = {
    spawnstate = S_TRCK,
    radius = 13*FRACUNIT,
    height = 7*FRACUNIT,
    flags = mobjinfo[MT_SPINDUST].flags
}

--Tire fire 
mobjinfo[MT_FIRE] = {
    spawnstate = S_FIRE,
    radius = 13*FRACUNIT,
    height = 7*FRACUNIT,
    flags = mobjinfo[MT_TRCK].flags|MF_FIRE
}

--The dust effect after Crescent explosion
mobjinfo[MT_BDST] = {
    spawnstate = S_BLAST_DUST,
    flags = MF_SCENERY|MF_NOGRAVITY
}


--Heavy blast
mobjinfo[MT_WBLS] = {
    spawnstate = S_BLAST_SHOT,
    deathstate = S_BLAST_EXPLODE,
    deathsound = sfx_expld,
    speed = 90*FRACUNIT,
    radius = 16*FRACUNIT,
    height = 16*FRACUNIT,
    damage = 2,
    flags = MF_MISSILE|MF2_SUPERFIRE
}

--[[
--Explosion caused by the blast
mobjinfo[MT_EXPL] = {
    spawnstate = S_BLAST_SHOT,
    speed = 70*FRACUNIT,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    damage = 2,
    flags = MF_MISSILE|MF_GRENADEBOUNCE|MF_NOGRAVITY
}
]]--


--A bullet
mobjinfo[MT_WBUL] = {
    spawnstate = S_BULL_SHOT,
    speed = 100*FRACUNIT,
    radius = 10*FRACUNIT,
    height = 10*FRACUNIT,
    damage = 1,
    flags = MF_MISSILE|MF_NOGRAVITY
}